//Autor: Peter Chobot, chobot@pobox.sk
package logistic;

import java.awt.event.*;
import java.awt.*;
import java.applet.*;
import java.lang.*;
import java.text.*;
import java.util.*;

public class LogFun extends Applet
{
  public static double x=0.07;
  public static double k=3.5;
  public static double k1=2.7;
  public static double k2=3.94;
  public static double y1=0.03;
  public static double y2=0.98;
  public static int iterNum=100;
  public static int prePoints=68;
  public static int iterNumZoom=100;
  public static int prePointsZoom=68;
  public static int numCharLines=0;
  public static boolean drawPoints=true;
  public static boolean customProfile=true;
  public static boolean differentParamZoom=false;

  CobwebCanvas cc = new CobwebCanvas(this);
  BifurCanvas bc = new BifurCanvas(this);
  TimeCanvas tc = new TimeCanvas(this);
  ZoomBifurCanvas zbc = new ZoomBifurCanvas(this);
  IterNumPanel inp = new IterNumPanel(this);
  IterNumPanelZoom inpz = new IterNumPanelZoom(this);

  public void init() {
    setLayout(new BorderLayout());
    Panel ppp = new Panel();
    ppp.setLayout(new BorderLayout());
    add(ppp, BorderLayout.CENTER);

    ppp.add(inp, BorderLayout.NORTH);
    ppp.add(cc, BorderLayout.WEST);
    ppp.add(bc, BorderLayout.CENTER);
    ppp.add(tc, BorderLayout.EAST);
    ppp.add(zbc, BorderLayout.SOUTH);

    add(inpz, BorderLayout.SOUTH);
  }

}

class IterNumPanelZoom extends Panel implements ActionListener, ItemListener
{
  LogFun applet;
  TextField iterNumFieldZoom;
  TextField prePointsFieldZoom;
  TextField numCharLinesField;
	Choice shapes;
  Checkbox synchroBox;

  public IterNumPanelZoom(LogFun applet) {

    this.applet = applet;
    setBackground(Color.white);
    Label lab = new Label("DETAIL:");
    lab.setFont(new Font("Dialog", Font.BOLD, 12));
    add(lab);

    shapes = new Choice();
  	shapes.addItem("Uvatesk pohad");
	  shapes.addItem("k=1 Vyhynutie");
	  shapes.addItem("k=1.8 Ustlenie bez prekmitu");
	  shapes.addItem("k=2.8 Ustlenie s prekmitom");
	  shapes.addItem("k=3.2 Perida 2");
	  shapes.addItem("k=3.54 Perida 4");
	  shapes.addItem("k=3.56 Perida 8");
	  shapes.addItem("k=3.8 pln chaos");
	  shapes.addItem("k=3.84 Perida 3");
	  shapes.addItem("Perida 6");
	  shapes.addItem("Perida 7");
	  shapes.addItem("Perida 5");
	  shapes.addItem("Perida 3");
	  shapes.addItem("Perida 3 detail");
	  shapes.addItem("Perida 7 detail");
	  shapes.addItem("Detail tesne za peridou 7");
	  shapes.addItem("Charakt. krivky v chaose");
	  shapes.addItem("Charakt. krivky bez chaosu");

  	add(shapes);
    add(new Label("Char. kriviek:"));
    add(numCharLinesField = new TextField(String.valueOf(LogFun.numCharLines)));
    numCharLinesField.setBackground(Color.orange);
    add(new Label("Iterci celkom:"));
    add(iterNumFieldZoom = new TextField(String.valueOf(LogFun.iterNumZoom),2));
    iterNumFieldZoom.setBackground(Color.lightGray);
    iterNumFieldZoom.setEditable(false);
    add(new Label("Iterci s vykresovanm:"));
    add(prePointsFieldZoom = new TextField(String.valueOf(LogFun.iterNumZoom-LogFun.prePointsZoom),2));
    prePointsFieldZoom.setBackground(Color.lightGray);
    prePointsFieldZoom.setEditable(false);
    add(synchroBox = new Checkbox("Zme",false));

    iterNumFieldZoom.addActionListener(this);
    prePointsFieldZoom.addActionListener(this);
    numCharLinesField.addActionListener(this);
  	shapes.addItemListener(this);
    synchroBox.addItemListener(this);
  }

  public void redraw() {
    iterNumFieldZoom.setText(String.valueOf(LogFun.iterNumZoom));
    if (LogFun.customProfile == true) shapes.select(0);
    numCharLinesField.setText(String.valueOf(LogFun.numCharLines));
    prePointsFieldZoom.setText(String.valueOf(LogFun.iterNumZoom - LogFun.prePointsZoom));
    if (LogFun.differentParamZoom) {
      synchroBox.setState(true);
      iterNumFieldZoom.setBackground(Color.orange);
      iterNumFieldZoom.setEditable(true);
      prePointsFieldZoom.setBackground(Color.orange);
      prePointsFieldZoom.setEditable(true);
    } else {
      iterNumFieldZoom.setBackground(Color.lightGray);
      iterNumFieldZoom.setEditable(false);
      prePointsFieldZoom.setBackground(Color.lightGray);
      prePointsFieldZoom.setEditable(false);
    }

  }

  public void paint(Graphics g) {
    Dimension d = getSize();
    g.setColor(Color.black);
    g.drawRect(0,0,d.width-1,d.height-1);
  }

  public void actionPerformed(ActionEvent e) {
    if (e.getSource() instanceof TextField) {
      LogFun.iterNumZoom = Integer.valueOf(iterNumFieldZoom.getText().trim().replace(',','.')).intValue();
      LogFun.prePointsZoom = LogFun.iterNumZoom - Integer.valueOf(prePointsFieldZoom.getText().trim().replace(',','.')).intValue();
      LogFun.numCharLines = Integer.valueOf(numCharLinesField.getText().trim()).intValue();


      if (LogFun.iterNumZoom < 0) {
        LogFun.iterNumZoom = 0;
      }
      if (LogFun.prePointsZoom > LogFun.iterNumZoom) {
        LogFun.prePointsZoom = LogFun.iterNumZoom;
      }
      if (LogFun.prePointsZoom < 0) {
        LogFun.prePointsZoom = 0;
      }
      if (LogFun.x > 1) {
        LogFun.x = 1;
      }
      if (LogFun.x < 0) {
        LogFun.x = 0;
      }
      if (LogFun.k > 4) {
        LogFun.k = 4;
      }
      if (LogFun.k < 1) {
        LogFun.k = 1;
      }

      LogFun.customProfile=true;
      redraw();
      applet.cc.redraw();
      applet.bc.redraw();
      applet.tc.redraw();
      applet.zbc.redraw();

    }
  }

  public void itemStateChanged(ItemEvent e) {
    if (e.getSource() instanceof Choice) {
      String choice = (String) e.getItem();
      if (choice.equals("Uvatesk pohad")) {
        LogFun.customProfile = true;

      } else if (choice.equals("k=1 Vyhynutie")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 100;
        LogFun.prePoints =  60;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  900;
        LogFun.k1 = 1;
        LogFun.k2 = 4;
        LogFun.k = 1;
        LogFun.x = 0.5;
        LogFun.y1 = 0;
        LogFun.y2 = 1;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("k=1.8 Ustlenie bez prekmitu")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 100;
        LogFun.prePoints =  60;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  900;
        LogFun.k1 = 1;
        LogFun.k2 = 4;
        LogFun.k = 1.8;
        LogFun.x = 0.1;
        LogFun.y1 = 0;
        LogFun.y2 = 1;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("k=2.8 Ustlenie s prekmitom")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 100;
        LogFun.prePoints =  60;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  900;
        LogFun.k1 = 1;
        LogFun.k2 = 4;
        LogFun.k = 2.8;
        LogFun.x = 0.1;
        LogFun.y1 = 0;
        LogFun.y2 = 1;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("k=3.2 Perida 2")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 100;
        LogFun.prePoints =  60;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  900;
        LogFun.k1 = 1;
        LogFun.k2 = 4;
        LogFun.k = 3.2;
        LogFun.x = 0.255;
        LogFun.y1 = 0;
        LogFun.y2 = 1;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("k=3.54 Perida 4")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 100;
        LogFun.prePoints =  60;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  900;
        LogFun.k1 = 1;
        LogFun.k2 = 4;
        LogFun.k = 3.54;
        LogFun.x = 0.5;
        LogFun.y1 = 0;
        LogFun.y2 = 1;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("k=3.56 Perida 8")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 100;
        LogFun.prePoints =  60;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  900;
        LogFun.k1 = 1;
        LogFun.k2 = 4;
        LogFun.k = 3.56;
        LogFun.x = 0.5;
        LogFun.y1 = 0;
        LogFun.y2 = 1;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("k=3.8 pln chaos")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 300;
        LogFun.prePoints =  200;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  900;
        LogFun.k1 = 1;
        LogFun.k2 = 4;
        LogFun.k = 3.8;
        LogFun.x = 0.5;
        LogFun.y1 = 0;
        LogFun.y2 = 1;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("k=3.84 Perida 3")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 100;
        LogFun.prePoints =  60;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  900;
        LogFun.k1 = 1;
        LogFun.k2 = 4;
        LogFun.k = 3.84;
        LogFun.x = 0.5;
        LogFun.y1 = 0;
        LogFun.y2 = 1;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("Perida 6")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 150;
        LogFun.prePoints =  80;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  750;
        LogFun.k1 = 3.5;
        LogFun.k2 = 4;
        LogFun.k = 3.6271;
        LogFun.x = 0.5;
        LogFun.y1 = 0;
        LogFun.y2 = 1;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("Perida 7")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 150;
        LogFun.prePoints =  80;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  750;
        LogFun.k1 = 3.5;
        LogFun.k2 = 4;
        LogFun.k = 3.702214;
        LogFun.x = 0.5;
        LogFun.y1 = 0;
        LogFun.y2 = 1;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("Perida 5")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 150;
        LogFun.prePoints =  80;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  750;
        LogFun.k1 = 3.5;
        LogFun.k2 = 4;
        LogFun.k = 3.7387;
        LogFun.x = 0.5;
        LogFun.y1 = 0;
        LogFun.y2 = 1;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("Perida 3")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 150;
        LogFun.prePoints =  80;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  750;
        LogFun.k1 = 3.5;
        LogFun.k2 = 4;
        LogFun.k = 3.8323;
        LogFun.x = 0.5;
        LogFun.y1 = 0;
        LogFun.y2 = 1;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("Perida 3 detail")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 150;
        LogFun.prePoints =  80;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  750;
        LogFun.k1 = 3.8;
        LogFun.k2 = 3.9;
        LogFun.k = 3.84;
        LogFun.x = 0.5;
        LogFun.y1 = 0.077;
        LogFun.y2 = 0.996;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("Perida 7 detail")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 150;
        LogFun.prePoints =  80;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  750;
        LogFun.k1 = 3.7;
        LogFun.k2 = 3.705;
        LogFun.k = 3.7018;
        LogFun.x = 0.5;
        LogFun.y1 = 0.234;
        LogFun.y2 = 0.948;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("Detail tesne za peridou 7")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 150;
        LogFun.prePoints =  80;
        LogFun.iterNumZoom = 10000;
        LogFun.prePointsZoom =  9600;
        LogFun.k1 = 3.702;
        LogFun.k2 = 3.70278;
        LogFun.k = 3.70201;
        LogFun.x = 0.5;
        LogFun.y1 = 0.48023;
        LogFun.y2 = 0.51618;
        LogFun.numCharLines=0;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("Charakt. krivky v chaose")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 150;
        LogFun.prePoints =  80;
        LogFun.iterNumZoom = 1000;
        LogFun.prePointsZoom =  750;
        LogFun.k1 = 3.5;
        LogFun.k2 = 4;
        LogFun.k = 3.5;
        LogFun.x = 0.5;
        LogFun.y1 = 0;
        LogFun.y2 = 1;
        LogFun.numCharLines=8;
        LogFun.differentParamZoom = true;
      } else if (choice.equals("Charakt. krivky bez chaosu")) {
        LogFun.customProfile = false;
        LogFun.iterNum = 150;
        LogFun.prePoints =  80;
        LogFun.iterNumZoom = 0;
        LogFun.prePointsZoom =  0;
        LogFun.k1 = 3.5;
        LogFun.k2 = 4;
        LogFun.k = 3.5;
        LogFun.x = 0.5;
        LogFun.y1 = 0;
        LogFun.y2 = 1;
        LogFun.numCharLines=8;
        LogFun.differentParamZoom = true;
      }

    } else if (e.getSource() instanceof Checkbox) {
    	boolean on = e.getStateChange() == ItemEvent.SELECTED;
	    LogFun.differentParamZoom = on;
      if (!on) {
        LogFun.prePointsZoom = LogFun.prePoints;
        LogFun.iterNumZoom = LogFun.iterNum;
        LogFun.customProfile = true;
      }
    }

    redraw();

    applet.cc.redraw();
    applet.bc.redraw();
    applet.tc.redraw();
    applet.zbc.redraw();
    applet.inp.redraw();
    redraw();
  }
}

class IterNumPanel extends Panel implements ActionListener , ItemListener
{
  LogFun applet;
  TextField iterNumField;
  TextField xField;
  TextField kField;
  TextField prePointsField;
  Checkbox drawPointsBox;

  public IterNumPanel(LogFun applet) {

    this.applet = applet;
    setBackground(Color.white);

    Label lab = new Label("GLOBAL:");
    lab.setFont(new Font("Dialog", Font.BOLD, 12));
    add(lab);

    add(new Label(" Iterci celkom:"));
    add(iterNumField = new TextField(String.valueOf(LogFun.iterNum),4));
    iterNumField.setBackground(Color.orange);
    add(new Label(" Iterci s vykresovanm:"));
    add(prePointsField = new TextField(String.valueOf(LogFun.iterNum-LogFun.prePoints),4));
    add(new Label(" x:"));
    add(xField = new TextField(String.valueOf(LogFun.x),4));
    add(new Label(" k:"));
    add(kField = new TextField(String.valueOf(LogFun.k),4));
    add(drawPointsBox = new Checkbox("Zvrazuj hodnoty",true));

    iterNumField.addActionListener(this);
    xField.addActionListener(this);
    kField.addActionListener(this);
    prePointsField.addActionListener(this);
    drawPointsBox.addItemListener(this);

  }

  public void redraw() {
    iterNumField.setText(String.valueOf(LogFun.iterNum));
    xField.setText(String.valueOf(LogFun.x));
    kField.setText(String.valueOf(LogFun.k));
    prePointsField.setText(String.valueOf(LogFun.iterNum - LogFun.prePoints));
  }

  public void paint(Graphics g) {
    Dimension d = getSize();
    g.setColor(Color.black);
    g.drawRect(0,0,d.width-1,d.height-1);
  }

  public void actionPerformed(ActionEvent e) {
    if (e.getSource() instanceof TextField) {
      LogFun.iterNum = Integer.valueOf(iterNumField.getText().trim().replace(',','.')).intValue();
      LogFun.x = Double.valueOf(xField.getText().trim().replace(',','.')).doubleValue();
      LogFun.k = Double.valueOf(kField.getText().trim().replace(',','.')).doubleValue();
      LogFun.prePoints = LogFun.iterNum - Integer.valueOf(prePointsField.getText().trim().replace(',','.')).intValue();

      if (LogFun.iterNum < 0) {
        LogFun.iterNum = 0;
      }
      if (LogFun.prePoints > LogFun.iterNum) {
        LogFun.prePoints = LogFun.iterNum;
      }
      if (LogFun.prePoints < 0) {
        LogFun.prePoints = 0;
      }
      if (LogFun.x > 1) {
        LogFun.x = 1;
      }
      if (LogFun.x < 0) {
        LogFun.x = 0;
      }
      if (LogFun.k > 4) {
        LogFun.k = 4;
      }
      if (LogFun.k < 1) {
        LogFun.k = 1;
      }

      if (!LogFun.differentParamZoom) {
        LogFun.iterNumZoom = LogFun.iterNum;
        LogFun.prePointsZoom = LogFun.prePoints;
      }

      redraw();

      applet.cc.redraw();
      applet.bc.redraw();
      applet.tc.redraw();
      applet.zbc.redraw();
      LogFun.customProfile=true;
      applet.inpz.redraw();
    }
  }

  public void itemStateChanged(ItemEvent e) {
  	Object src = e.getSource();
  	boolean on = e.getStateChange() == ItemEvent.SELECTED;
	  if (src == drawPointsBox) LogFun.drawPoints = on;
    applet.tc.redraw();
  }
}

class CobwebCanvas extends Canvas implements MouseListener, MouseMotionListener {
  LogFun applet;
  static final Dimension d = new Dimension(200,260);
  Image offscreen;
  Dimension offscreensize;
  Graphics offgraphics;
  boolean update;
  boolean clicked = false;
  int xpos;
  int ypos = (d.height-60) + 20;

  public CobwebCanvas(LogFun applet){
    this.applet = applet;
    addMouseListener(this);
    update = true;
    setSize(d);
    setBackground(Color.white);
  }

  public void paint(Graphics g) {

    if ((offscreen == null) || (d.width != offscreensize.width) || (d.height != offscreensize.height)) {
      offscreen = createImage(d.width, d.height);
      offscreensize = d;
      if (offgraphics != null) {
        offgraphics.dispose();
      }
      offgraphics = offscreen.getGraphics();
      offgraphics.setFont(getFont());
    }

    if (update == true) {
      update = false;
      offgraphics.setColor(Color.white);
      offgraphics.fillRect(0, 0, d.width, d.height);
      offgraphics.setColor(Color.black);
      offgraphics.drawRect(0,20,d.width-1,d.height-61);

      FontMetrics fm = offgraphics.getFontMetrics();
      int w = fm.stringWidth("COBWEB DIAGRAM") + 10;
      int h = fm.getHeight() + 4;
      offgraphics.setColor(Color.black);
      offgraphics.drawString("COBWEB DIAGRAM", d.width/2 - (w-10)/2, (10 - (h-4)/2) + fm.getAscent());

      double deltax = 1.0/d.width;

      for (int i=0;i<d.width;i++) {
        offgraphics.drawLine((int)(d.width*i*deltax),
        (int)((d.height-60) + 20 - (d.height-60)*(LogFun.k*i*deltax*(1-i*deltax))),
        (int)(d.width*(i+1)*deltax),
        (int)((d.height-60) + 20 - (d.height-60)*(LogFun.k*(i+1)*deltax*(1-(i+1)*deltax))));
      }

      offgraphics.drawLine(0,(d.height-60)+20,d.width,20);

      double x0 = LogFun.x;
      double y0 = LogFun.k*x0*(1-x0);
      double y1;
      offgraphics.setColor(Color.lightGray);
      offgraphics.drawLine((int)(x0*d.width),(int)((d.height-60)+20),(int)(x0*d.width),(int)((d.height-60)+20-y0*(d.height-60)));
      for(int i=1; i < LogFun.iterNum;i++) {
        offgraphics.setColor((i >= LogFun.prePoints) ? Color.red : Color.lightGray);
        y1 = LogFun.k*y0*(1-y0);
        offgraphics.drawLine((int)(x0*d.width),(int)((d.height-60)+20-y0*(d.height-60)),(int)(y0*d.width),(int)((d.height-60)+20-y0*(d.height-60)));
        offgraphics.drawLine((int)(y0*d.width),(int)((d.height-60)+20-y0*(d.height-60)),(int)(y0*d.width),(int)((d.height-60)+20-y1*(d.height-60)));
        x0 = y0;
        y0 = y1;
      }

    }

    g.drawImage(offscreen, 0, 0, null);
    g.setColor(Color.gray);
    g.fillRect(2,(d.height-60)+25,d.width-4,10);

    xpos = (int) (LogFun.x*d.width);

    g.setColor(clicked ? Color.red : Color.orange);
    g.fillRect(xpos-4,ypos,8,20);
    g.setColor(Color.black);
    g.drawRect(xpos-4,ypos,8,20);

    FontMetrics fm = g.getFontMetrics();
    int w = fm.stringWidth("x = "+LogFun.x) + 10;
    int h = fm.getHeight() + 4;
    g.setColor(Color.black);
    g.drawString("x = "+LogFun.x, d.width/2 - (w-10)/2, ((d.height-60)+50 - (h-4)/2) + fm.getAscent());

    g.setColor(Color.black);
    g.drawRect(0,0,d.width-1,d.height-1);
  }

  public void redraw() {
    update = true;
    repaint();
  }

  public void mouseClicked(MouseEvent e) {
  }

  public void mousePressed(MouseEvent e) {
    int x = e.getX();
    int y = e.getY();
    if (((x < xpos+4) && (x > xpos-4) && (y < ypos+20) && (y > ypos)) || ((y < (d.height-60)+35) && (y > (d.height-60)+25))){
      addMouseMotionListener(this);
      clicked = true;
      repaint();
    }
    e.consume();
  }

  public void mouseReleased(MouseEvent e) {
    removeMouseMotionListener(this);
    if (clicked == true) {
      int x = e.getX();
      clicked = false;
      if ((x <= d.width) && (x >= 0)) {
        LogFun.x = (double)(x)/d.width;
      }

      redraw();
      LogFun.customProfile = true;
      applet.inp.redraw();
      applet.tc.redraw();
      applet.bc.redraw();
      applet.zbc.redraw();
      applet.inpz.redraw();
    }
    e.consume();
  }

  public void mouseEntered(MouseEvent e) {
  }

  public void mouseExited(MouseEvent e) {
  }

  public void mouseDragged(MouseEvent e) {
    int x = e.getX();
    if ((x <= d.width) && (x >= 0)){
      LogFun.x = (double)(x)/d.width;
    }
    redraw();
    applet.tc.redraw();
    e.consume();
  }

  public void mouseMoved(MouseEvent e) {
  }


}

class TimeCanvas extends Canvas implements MouseListener, MouseMotionListener {
  LogFun applet;
  static final Dimension d = new Dimension(300,260);
  Image offscreen;
  Dimension offscreensize;
  Graphics offgraphics;
  boolean update;
  boolean clicked = false;
  int xpos;
  int ypos = (d.height-60) + 20;

  public TimeCanvas(LogFun applet){
    this.applet = applet;
    addMouseListener(this);
    update = true;
    setSize(d);
    setBackground(Color.white);
  }

  public void paint(Graphics g) {

    if ((offscreen == null) || (d.width != offscreensize.width) || (d.height != offscreensize.height)) {
      offscreen = createImage(d.width, d.height);
      offscreensize = d;
      if (offgraphics != null) {
        offgraphics.dispose();
      }
      offgraphics = offscreen.getGraphics();
      offgraphics.setFont(getFont());
    }

    if (update == true) {
      update = false;
      offgraphics.setColor(Color.white);
      offgraphics.fillRect(0, 0, d.width, d.height);
      offgraphics.setColor(Color.black);
      offgraphics.drawRect(0,20,d.width-1,d.height-61);

      FontMetrics fm = offgraphics.getFontMetrics();
      int w = fm.stringWidth("DIAGRAM ITERCI V ASE") + 10;
      int h = fm.getHeight() + 4;
      offgraphics.setColor(Color.black);
      offgraphics.drawString("DIAGRAM ITERCI V ASE", d.width/2 - (w-10)/2, (10 - (h-4)/2) + fm.getAscent());

      double x0 = LogFun.x;
      offgraphics.setColor(Color.lightGray);
      for(int i=1; i <= LogFun.iterNum; i++) {
        double x1 = LogFun.k*x0*(1-x0);
        offgraphics.setColor((i > LogFun.prePoints) ? Color.red : Color.lightGray);
        offgraphics.drawLine((int)(((double)(i-1)/LogFun.iterNum)*d.width),(int)((d.height-60)+20-x0*(d.height-60)),(int)(((double)(i)/LogFun.iterNum)*d.width),(int)((d.height-60)+20-x1*(d.height-60)));

        offgraphics.setColor(Color.black);
        if ((i != 1) && (LogFun.drawPoints == true)) offgraphics.fillRect((int)(((double)(i-1)/LogFun.iterNum)*d.width)-1,(int)((d.height-60)+20-x0*(d.height-60))-1,3,3);

        x0 = x1;
      }

    }

    g.drawImage(offscreen, 0, 0, null);
    g.setColor(Color.gray);
    g.fillRect(2,(d.height-60)+25,d.width-4,10);

    xpos = (int) (((double)(LogFun.prePoints)/LogFun.iterNum)*d.width);

    g.setColor(clicked ? Color.red : Color.orange);
    g.fillRect(xpos-4,ypos,8,20);
    g.setColor(Color.black);
    g.drawRect(xpos-4,ypos,8,20);

    FontMetrics fm = g.getFontMetrics();
    int w = fm.stringWidth("#PREPOINTS = "+LogFun.prePoints+"      #DRAWPOINTS = "+(LogFun.iterNum-LogFun.prePoints)) + 10;
    int h = fm.getHeight() + 4;
    g.drawString("#PREPOINTS = "+LogFun.prePoints+"      #DRAWPOINTS = "+(LogFun.iterNum-LogFun.prePoints), d.width/2 - (w-10)/2, ((d.height-60)+50 - (h-4)/2) + fm.getAscent());

    g.setColor(Color.darkGray);
    g.drawLine(xpos,ypos,xpos,20);
    g.setColor(Color.black);
    g.drawRect(0,0,d.width-1,d.height-1);
  }

  public void redraw() {
    update = true;
    repaint();
  }

  public void mouseClicked(MouseEvent e) {
  }

  public void mousePressed(MouseEvent e) {
    int x = e.getX();
    int y = e.getY();
    if (((x < xpos+4) && (x > xpos-4) && (y < ypos+20) && (y > ypos)) || ((y < (d.height-60)+35) && (y > (d.height-60)+25))){
      addMouseMotionListener(this);
      clicked = true;
      repaint();
    }
    e.consume();
  }

  public void mouseReleased(MouseEvent e) {
    removeMouseMotionListener(this);
    if (clicked == true) {
      int x = e.getX();
      clicked = false;
      if ((x <= d.width) && (x >= 0)) {
        LogFun.prePoints = (int)(((double)(x)/d.width) * LogFun.iterNum);
        if (!LogFun.differentParamZoom) LogFun.prePointsZoom = LogFun.prePoints;
      }

      redraw();
      LogFun.customProfile = true;
      applet.inp.redraw();
      applet.inpz.redraw();
      applet.cc.redraw();
      applet.bc.redraw();
      applet.zbc.redraw();

    }
    e.consume();
  }

  public void mouseEntered(MouseEvent e) {
  }

  public void mouseExited(MouseEvent e) {
  }

  public void mouseDragged(MouseEvent e) {
    int x = e.getX();
    if ((x <= d.width) && (x >= 0)){
      LogFun.prePoints = (int)(((double)(x)/d.width) * LogFun.iterNum);
    }
    redraw();
    applet.cc.redraw();
    e.consume();
  }

  public void mouseMoved(MouseEvent e) {
  }

}

class BifurCanvas extends Canvas implements MouseListener, MouseMotionListener {
  LogFun applet;
  static final Dimension d = new Dimension(300,260);
  Image offscreen;
  Dimension offscreensize;
  Graphics offgraphics;
  boolean update;
  boolean clicked = false;
  boolean framing = false;
  double k1,k2,y1,y2;
  int xpos;
  int ypos = (d.height-60) + 20;

  public BifurCanvas(LogFun applet){
    this.applet = applet;
    addMouseListener(this);
    update = true;
    setSize(d);
    setBackground(Color.white);
  }

  public void paint(Graphics g) {

    if ((offscreen == null) || (d.width != offscreensize.width) || (d.height != offscreensize.height)) {
      offscreen = createImage(d.width, d.height);
      offscreensize = d;
      if (offgraphics != null) {
        offgraphics.dispose();
      }
      offgraphics = offscreen.getGraphics();
      offgraphics.setFont(getFont());
    }

    if (update == true) {
      update = false;
      offgraphics.setColor(Color.white);
      offgraphics.fillRect(0, 0, d.width, d.height);

      FontMetrics fm = offgraphics.getFontMetrics();
      int w = fm.stringWidth("BIFURKAN DIAGRAM") + 10;
      int h = fm.getHeight() + 4;
      offgraphics.setColor(Color.black);
      offgraphics.drawString("BIFURKAN DIAGRAM", d.width/2 - (w-10)/2, (10 - (h-4)/2) + fm.getAscent());

      offgraphics.setColor(Color.red);

      for (int j=1;j < (d.width-1);j++) {
        double x0 = LogFun.x;
        for(int i=1; i <= LogFun.iterNum; i++) {
          double x1 = (((double)(j)*3)/d.width +1)*x0*(1-x0);
          if (i > LogFun.prePoints) {
            offgraphics.drawLine(j,(int)((d.height-60)+20-x1*(d.height-60)),j,(int)((d.height-60)+20-x1*(d.height-60)));
          }
          x0 = x1;
        }
      }
    }

    g.drawImage(offscreen, 0, 0, null);
    g.setColor(Color.gray);
    g.fillRect(2,(d.height-60)+25,d.width-4,10);

    xpos = (int) (((LogFun.k-1)/3.0)*d.width);

    g.setColor(clicked ? Color.red : Color.orange);
    g.fillRect(xpos-4,ypos,8,20);
    g.setColor(Color.black);
    g.drawRect(xpos-4,ypos,8,20);

    FontMetrics fm = g.getFontMetrics();
    int w = fm.stringWidth("k = "+LogFun.k) + 10;
    int h = fm.getHeight() + 4;
    g.setColor(Color.black);
    g.drawString("k = "+LogFun.k, d.width/2 - (w-10)/2, ((d.height-60)+50 - (h-4)/2) + fm.getAscent());

    g.setColor(Color.darkGray);
    g.drawLine(xpos,ypos,xpos,20);

    g.setColor(Color.darkGray);

    if ((LogFun.k2>LogFun.k1) && (LogFun.y2>LogFun.y1)) {
      g.drawRect((int) (((LogFun.k1-1)/3.0)*d.width), (int)((d.height-60)+20-LogFun.y2*(d.height-60)), (int) (((double)(LogFun.k2-LogFun.k1)/3.0)*d.width)+1, (int)((double)(LogFun.y2-LogFun.y1)*(d.height-60)) -1        );
    } else
    if ((LogFun.k2<LogFun.k1) && (LogFun.y2>LogFun.y1)) {
      g.drawRect((int) (((LogFun.k2-1)/3.0)*d.width), (int)((d.height-60)+20-LogFun.y2*(d.height-60)), (int) (((double)(LogFun.k1-LogFun.k2)/3.0)*d.width)+1, (int)((double)(LogFun.y2-LogFun.y1)*(d.height-60)) -1        );
    } else
    if ((LogFun.k2>LogFun.k1) && (LogFun.y2<LogFun.y1)) {
      g.drawRect((int) (((LogFun.k1-1)/3.0)*d.width), (int)((d.height-60)+20-LogFun.y1*(d.height-60)), (int) (((double)(LogFun.k2-LogFun.k1)/3.0)*d.width)+1, (int)((double)(LogFun.y1-LogFun.y2)*(d.height-60)) -1        );
    } else
    if ((LogFun.k2<LogFun.k1) && (LogFun.y2<LogFun.y1)) {
      g.drawRect((int) (((LogFun.k2-1)/3.0)*d.width), (int)((d.height-60)+20-LogFun.y1*(d.height-60)), (int) (((double)(LogFun.k1-LogFun.k2)/3.0)*d.width)+1, (int)((double)(LogFun.y1-LogFun.y2)*(d.height-60)) -1        );
    }

    g.setColor(Color.black);
    g.drawRect(0,20,d.width-1,d.height-61);
    g.drawRect(0,0,d.width-1,d.height-1);
  }

  public void redraw() {
    update = true;
    repaint();
  }

  public void mouseClicked(MouseEvent e) {
  }

  public void mousePressed(MouseEvent e) {
    int x = e.getX();
    int y = e.getY();

    k1=LogFun.k1;
    k2=LogFun.k2;
    y1=LogFun.y1;
    y2=LogFun.y2;

    if (((x < xpos+4) && (x > xpos-4) && (y < ypos+20) && (y > ypos)) || ((y < (d.height-60)+35) && (y > (d.height-60)+25))){
      addMouseMotionListener(this);
      clicked = true;
      repaint();
    }
    if ((y < (d.height-40)) && (y > 20)) {
      addMouseMotionListener(this);
      framing = true;
      LogFun.k1= ((double)(x)/d.width)*3 + 1;
      LogFun.k2= ((double)(x)/d.width)*3 + 1;
      LogFun.y1= 1.0 - (double)(y-20)/(d.height-60);
      LogFun.y2= 1.0 - (double)(y-20)/(d.height-60);
      repaint();

    }
    e.consume();
  }

  public void mouseReleased(MouseEvent e) {
    removeMouseMotionListener(this);
    if (clicked == true) {
      int x = e.getX();
      clicked = false;
      if ((x <= d.width) && (x >= 0)) {
        LogFun.k = ((double)(x)/d.width)*3 + 1;
      }

      repaint();
      applet.zbc.repaint();
      applet.inp.redraw();
      applet.cc.redraw();
      applet.tc.redraw();
      LogFun.customProfile=true;
      applet.inpz.redraw();

    }

    if (framing == true) {
      int x = e.getX();
      int y = e.getY();
      framing = false;

      if ((x<d.width) && (x>0) && (y>20) && (y<d.height -40)) {
        LogFun.y2= 1.0 - (double)(y-20)/(d.height-60);
        LogFun.k2= ((double)(x)/d.width)*3 + 1;
      }
      if (LogFun.k2<LogFun.k1) {
        double help = LogFun.k2;
        LogFun.k2 = LogFun.k1;
        LogFun.k1 = help;
      }
      if (LogFun.y2<LogFun.y1) {
        double help = LogFun.y2;
        LogFun.y2 = LogFun.y1;
        LogFun.y1 = help;
      }

      if ((LogFun.k2==LogFun.k1) || (LogFun.y2==LogFun.y1)) {
        if (e.getModifiers() == e.BUTTON3_MASK) {
          LogFun.k2+=(k2-k1)*0.833;
          LogFun.k1-=(k2-k1)*0.833;
          LogFun.y2+=(y2-y1)*0.833;
          LogFun.y1-=(y2-y1)*0.833;
        } else {
          LogFun.k2+=.5;
          LogFun.k1-=.5;
          LogFun.y2+=.11;
          LogFun.y1-=.11;
        }

        if (LogFun.k2 > 4) {
          LogFun.k2=4;
        }
        if (LogFun.y2 > 1) {
          LogFun.y2=1;
        }
        if (LogFun.k1 < 1) {
          LogFun.k1=1;
        }
        if (LogFun.y1 < 0) {
          LogFun.y1=0;
        }
      }

      repaint();
      applet.zbc.redraw();
      LogFun.customProfile=true;
      applet.inpz.redraw();
    }
    e.consume();
  }

  public void mouseEntered(MouseEvent e) {
  }

  public void mouseExited(MouseEvent e) {
  }

  public void mouseDragged(MouseEvent e) {
    int x = e.getX();
    int y = e.getY();

    if (clicked == true) {
      if ((x <= d.width) && (x >= 0)){
          LogFun.k = ((double)(x)/d.width)*3 + 1;
      }
      repaint();
      applet.zbc.repaint();
      applet.cc.redraw();
      applet.tc.redraw();
    }
    if (framing == true) {
      if ((x<d.width) && (x>0) && (y>20) && (y<d.height -40)) {
        LogFun.y2= 1.0 - (double)(y-20)/(d.height-60);
        LogFun.k2= ((double)(x)/d.width)*3 + 1;
      }
      repaint();
    }
    e.consume();
  }

  public void mouseMoved(MouseEvent e) {
  }


}
class ZoomBifurCanvas extends Canvas implements MouseListener, MouseMotionListener {
  LogFun applet;
  static final Dimension d = new Dimension(800,319);
  Image offscreen;
  Dimension offscreensize;
  Graphics offgraphics;
  boolean update;
  boolean clicked = false;
  boolean framing = false;
  double k1,k2,y1,y2;
  int xpos;
  int ypos = (d.height-60) + 20;

  public ZoomBifurCanvas(LogFun applet){
    this.applet = applet;
    addMouseListener(this);
    update = true;
    setSize(d);
    setBackground(Color.white);
  }

  public void paint(Graphics g) {

    if ((offscreen == null) || (d.width != offscreensize.width) || (d.height != offscreensize.height)) {
      offscreen = createImage(d.width, d.height);
      offscreensize = d;
      if (offgraphics != null) {
        offgraphics.dispose();
      }
      offgraphics = offscreen.getGraphics();
      offgraphics.setFont(getFont());
    }

    if (update == true) {
      update = false;
      k1=LogFun.k1;
      k2=LogFun.k2;
      y1=LogFun.y1;
      y2=LogFun.y2;
      offgraphics.setColor(Color.white);
      offgraphics.fillRect(0, 0, d.width, d.height);
      offgraphics.setColor(Color.black);
      offgraphics.drawRect(0,20,d.width-1,d.height-61);

      FontMetrics fm = offgraphics.getFontMetrics();
      int w = fm.stringWidth("DETAILN BIFURKAN DIAGRAM") + 10;
      int h = fm.getHeight() + 4;
      offgraphics.setColor(Color.black);
      offgraphics.drawString("DETAILN BIFURKAN DIAGRAM", d.width/2 - (w-10)/2, (10 - (h-4)/2) + fm.getAscent());

      for (int j=1;j < (d.width-1);j++) {
        offgraphics.setColor(Color.red);
        double x0 = LogFun.x;
        for(int i=1; i <= LogFun.iterNumZoom; i++) {
          double x1 = (((double)(j)*(LogFun.k2-LogFun.k1))/d.width + LogFun.k1)*x0*(1-x0);
          if ((i > LogFun.prePointsZoom) && (x1>=LogFun.y1) && (x1<=LogFun.y2)) {
            offgraphics.drawLine(j,(int)((d.height-60)+20-((x1-y1)*(d.height-60))/(y2-y1)),j,(int)((d.height-60)+20-((x1-y1)*(d.height-60))/(y2-y1)));
          }
          x0 = x1;
        }
//zelene charakterist.krivky
        offgraphics.setColor(Color.green);
        x0 = 0.5;
        for(int i=1; i <= LogFun.numCharLines; i++) {
          double x1 = (((double)(j)*(LogFun.k2-LogFun.k1))/d.width + LogFun.k1)*x0*(1-x0);
          if ((x1>=LogFun.y1) && (x1<=LogFun.y2)) {
            offgraphics.drawLine(j,(int)((d.height-60)+20-((x1-y1)*(d.height-60))/(y2-y1)),j,(int)((d.height-60)+20-((x1-y1)*(d.height-60))/(y2-y1)));
          }
          x0 = x1;
        }



      }
    }

    g.drawImage(offscreen, 0, 0, null);
    g.setColor(Color.gray);
    g.fillRect(2,(d.height-60)+25,d.width-4,10);

    if (framing == false) {
      xpos = (int) (((LogFun.k-LogFun.k1)/(LogFun.k2-LogFun.k1))*d.width);
    }

    g.setColor(clicked ? Color.red : Color.orange);
    g.fillRect(xpos-4,ypos,8,20);
    g.setColor(Color.black);
    g.drawRect(xpos-4,ypos,8,20);

    FontMetrics fm = g.getFontMetrics();
    int w = fm.stringWidth("k = "+LogFun.k);
    int h = fm.getHeight();
    g.setColor(Color.black);
    g.drawString("k = "+LogFun.k, d.width/2 - (w)/2, ((d.height-60)+50 - (h)/2) + fm.getAscent());

    w = fm.stringWidth(""+y1);
    h = fm.getHeight();
    g.drawString(""+y1, 3, ((d.height-60)+10 - (h)/2) + fm.getAscent());

    w = fm.stringWidth(""+y2);
    h = fm.getHeight();
    g.drawString(""+y2, 3, 30 - (h)/2 + fm.getAscent());

    w = fm.stringWidth(""+k1);
    h = fm.getHeight();
    g.drawString(""+k1, 3, ((d.height-60)+50 - (h)/2) + fm.getAscent());

    w = fm.stringWidth(""+k2);
    h = fm.getHeight();
    g.setColor(Color.black);
    g.drawString(""+k2, d.width - w - 4, ((d.height-60)+50 - (h)/2) + fm.getAscent());

    g.setColor(Color.darkGray);
    g.drawLine(xpos,ypos,xpos,20);

    g.setColor(Color.darkGray);

    if (framing == true) {
      if ((LogFun.k2>LogFun.k1) && (LogFun.y2>LogFun.y1)) {
        g.drawRect((int) (((LogFun.k1-k1)/(k2-k1))*d.width), (int)((d.height-60)+20-((LogFun.y2-y1)*(d.height-60))/(y2-y1)), (int) (((double)(LogFun.k2-LogFun.k1)/(k2-k1))*d.width)+1, (int)((double)((LogFun.y2-LogFun.y1)/(y2-y1))*(d.height-60))        );
      }
      if ((LogFun.k2<LogFun.k1) && (LogFun.y2>LogFun.y1)) {
        g.drawRect((int) (((LogFun.k2-k1)/(k2-k1))*d.width), (int)((d.height-60)+20-((LogFun.y2-y1)*(d.height-60))/(y2-y1)), (int) (((double)(LogFun.k1-LogFun.k2)/(k2-k1))*d.width)+1, (int)((double)((LogFun.y2-LogFun.y1)/(y2-y1))*(d.height-60))        );
      }
      if ((LogFun.k2>LogFun.k1) && (LogFun.y2<LogFun.y1)) {
        g.drawRect((int) (((LogFun.k1-k1)/(k2-k1))*d.width), (int)((d.height-60)+20-((LogFun.y1-y1)*(d.height-60))/(y2-y1)), (int) (((double)(LogFun.k2-LogFun.k1)/(k2-k1))*d.width)+1, (int)((double)((LogFun.y1-LogFun.y2)/(y2-y1))*(d.height-60))        );
      }
      if ((LogFun.k2<LogFun.k1) && (LogFun.y2<LogFun.y1)) {
        g.drawRect((int) (((LogFun.k2-k1)/(k2-k1))*d.width), (int)((d.height-60)+20-((LogFun.y1-y1)*(d.height-60))/(y2-y1)), (int) (((double)(LogFun.k1-LogFun.k2)/(k2-k1))*d.width)+1, (int)((double)((LogFun.y1-LogFun.y2)/(y2-y1))*(d.height-60))        );
      }
    }

    g.setColor(Color.black);
    g.drawRect(0,0,d.width-1,d.height-1);
  }

  public void redraw() {
    update = true;
    repaint();
  }

  public void mouseClicked(MouseEvent e) {
  }

  public void mousePressed(MouseEvent e) {
    int x = e.getX();
    int y = e.getY();
    if (((x < xpos+4) && (x > xpos-4) && (y < ypos+20) && (y > ypos)) || ((y < (d.height-60)+35) && (y > (d.height-60)+25))){
      addMouseMotionListener(this);
      clicked = true;
      repaint();
    }
    if ((y < (d.height-40)) && (y > 20)) {
      addMouseMotionListener(this);
      framing = true;
      LogFun.k1= ((double)(x)/d.width)*(k2-k1) + k1;
      LogFun.k2= ((double)(x)/d.width)*(k2-k1) + k1;

      LogFun.y1= ((double)(y2-y1)*(d.height-40-y))/(d.height-60)+y1;
      LogFun.y2= ((double)(y2-y1)*(d.height-40-y))/(d.height-60)+y1;
      repaint();

    }
    e.consume();
  }

  public void mouseReleased(MouseEvent e) {
    removeMouseMotionListener(this);
    if (clicked == true) {
      int x = e.getX();
      clicked = false;
      if ((x <= d.width) && (x >= 0)) {
        LogFun.k = ((double)(x)/d.width)*(LogFun.k2-LogFun.k1) + LogFun.k1;
      }

      repaint();
      applet.bc.repaint();
      applet.inp.redraw();
      applet.cc.redraw();
      applet.tc.redraw();
      LogFun.customProfile=true;
      applet.inpz.redraw();
    }

    if (framing == true) {
      int x = e.getX();
      int y = e.getY();
      framing = false;

      if ((x<d.width) && (x>0) && (y>20) && (y<d.height -40)) {
        LogFun.y2= ((double)(y2-y1)*(d.height-40-y))/(d.height-60)+y1;
        LogFun.k2= ((double)(x)/d.width)*(k2-k1) + k1;
      }
      if (LogFun.k2<LogFun.k1) {
        double help = LogFun.k2;
        LogFun.k2 = LogFun.k1;
        LogFun.k1 = help;
      }
      if (LogFun.y2<LogFun.y1) {
        double help = LogFun.y2;
        LogFun.y2 = LogFun.y1;
        LogFun.y1 = help;
      }
      if ((LogFun.k2==LogFun.k1) || (LogFun.y2==LogFun.y1)) {
        if (e.getModifiers() == e.BUTTON3_MASK) {
          LogFun.k2+=(k2-k1)*0.833;
          LogFun.k1-=(k2-k1)*0.833;
          LogFun.y2+=(y2-y1)*0.833;
          LogFun.y1-=(y2-y1)*0.833;

          if (LogFun.k2 > 4) {
            LogFun.k2=4;
          }
          if (LogFun.y2 > 1) {
            LogFun.y2=1;
          }
          if (LogFun.k1 < 1) {
            LogFun.k1=1;
          }
          if (LogFun.y1 < 0) {
            LogFun.y1=0;
          }

        } else {
          LogFun.k2+=(k2-k1)*.3;
          LogFun.k1-=(k2-k1)*.3;
          LogFun.y2+=(y2-y1)*.3;
          LogFun.y1-=(y2-y1)*.3;

          if (LogFun.k2 > k2) {
            LogFun.k2=k2;
          }
          if (LogFun.y2 > y2) {
            LogFun.y2=y2;
          }
          if (LogFun.k1 < k1) {
            LogFun.k1=k1;
          }
          if (LogFun.y1 < y1) {
            LogFun.y1=y1;
          }

        }
      }

      redraw();
      applet.bc.repaint();
      LogFun.customProfile=true;
      applet.inpz.redraw();
    }
    e.consume();
  }

  public void mouseEntered(MouseEvent e) {
  }

  public void mouseExited(MouseEvent e) {
  }

  public void mouseDragged(MouseEvent e) {
    int x = e.getX();
    int y = e.getY();

    if (clicked == true) {
      if ((x <= d.width) && (x >= 0)){
          LogFun.k = ((double)(x)/d.width)*(LogFun.k2-LogFun.k1) + LogFun.k1;
      }
      repaint();
      applet.bc.repaint();
      applet.cc.redraw();
      applet.tc.redraw();
    }
    if (framing == true) {
      if ((x<d.width) && (x>0) && (y>20) && (y<d.height -40)) {
        LogFun.y2= ((double)(y2-y1)*(d.height-40-y))/(d.height-60)+y1;
        LogFun.k2= ((double)(x)/d.width)*(k2-k1) + k1;
      }
      repaint();
    }
    e.consume();
  }

  public void mouseMoved(MouseEvent e) {
  }


}


  
